//
//   Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010,
//   2011 Free Software Foundation, Inc
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef GTK_GLU_GTKGLEXT_H
#define GTK_GLU_GTKGLEXT_H

#ifdef HAVE_CONFIG_H
#include "gnashconfig.h"
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <boost/scoped_array.hpp>

#include <gtk/gtkgl.h>

#include "opengl/Renderer_ogl.h"
#include "gtk_glue.h"
#include "tu_opengl_includes.h"

namespace gnash
{

class GtkGlExtGlue : public GtkGlue
{
  public:
    GtkGlExtGlue();
    ~GtkGlExtGlue();

    bool init(int argc, char **argv[]);
    void prepDrawingArea(GtkWidget *drawing_area);
    Renderer* createRenderHandler();
    void render();
    void render(int /*minx*/, int /*miny*/, int /*maxx*/, int /*maxy*/) { render(); };
    void configure(GtkWidget *const widget, GdkEventConfigure *const event);
  private:
    GdkGLConfig *_glconfig;
};

} // end of gnash namespace

// end of GNASH_GTK_GLEXT_H
#endif

// local Variables:
// mode: C++
// indent-tabs-mode: nil
// End:
